#include <PWMServo.h> 

#define HOME 90
#define MAX_ANGLE 180
#define MIN_ANGLE 0

#define MOVE_LEFT 0x01
#define MOVE_RIGHT 0x02
#define MOVE_HOME 0x03

int STEP_VALUE = 4;

PWMServo myservo;
int position = HOME;
bool moveKnob = false;
 
void setup() { 
	Serial.begin(9600);
	myservo.attach(SERVO_PIN_A); 
	myservo.write(position);
	Serial.println("Welcome!");
} 
 
 
void loop() {
	if (moveKnob) {
		myservo.write(position);
		delay(15);
		moveKnob = false;
	}
	serialEvent();
} 

void serialEvent() {
	while (Serial.available() < 2) {} // Wait for 2 bytes of data
	STEP_VALUE = (byte)Serial.read(); // First byte is the step increment (higher is faster)
	byte data = (byte)Serial.read();  // The movement command
	Serial.println(data, DEC);
	switch (data) {
		case MOVE_LEFT:
			if (position < MAX_ANGLE - STEP_VALUE) position += STEP_VALUE;
			break;
		case MOVE_RIGHT:
			if (position > MIN_ANGLE + STEP_VALUE) position -= STEP_VALUE;
			break;
		case MOVE_HOME:
			position = HOME;
			break;				
	}
	moveKnob = true;
}